﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.SilverlightEdition;
using System.Drawing;
using System.Globalization;
using System.Reflection;
using System.Collections.ObjectModel;

public class CustomServerLayerOverlay : ServerLayerOverlay
{
    public CustomServerLayerOverlay(string id)
        : base(id)
    { }

    protected override void DrawCore(GeoCanvas canvas, object nativeImage, RectangleShape canvasExtent, GeographyUnit mapUnit)
    {
        Collection<SimpleCandidate> labeledFeaturesInLayers = new Collection<SimpleCandidate>();
        foreach (Layer layer in Layers)
        {
            canvas.BeginDrawing(nativeImage, canvasExtent, mapUnit);
            lock (layer)
            {
                layer.Open();
                layer.Draw(canvas, labeledFeaturesInLayers);
            }
            canvas.EndDrawing();
        }
    }
}

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            //System.IO.FileStream fs = new FileStream(@"D:\Test3.txt", FileMode.OpenOrCreate, FileAccess.Write);
            //StreamWriter sw=new StreamWriter(fs);
            Trace.Write("Default aspx: in page load begining");
           
            
            EcwRasterLayer ecwRasterLayer_1 = new EcwRasterLayer(MapPath("~/App_Data/q3605sw.ecw"));
            ecwRasterLayer_1.UpperThreshold = double.MaxValue;
            ecwRasterLayer_1.LowerThreshold = 0;

            EcwRasterLayer ecwRasterLayer_2 = new EcwRasterLayer(MapPath("~/App_Data/q3505nw.ecw"));
            ecwRasterLayer_2.UpperThreshold = double.MaxValue;
            ecwRasterLayer_2.LowerThreshold = 0;

            EcwRasterLayer ecwRasterLayer_3 = new EcwRasterLayer(MapPath("~/App_Data/q3606se.ecw"));
            ecwRasterLayer_3.UpperThreshold = double.MaxValue;
            ecwRasterLayer_3.LowerThreshold = 0;

            EcwRasterLayer ecwRasterLayer_4 = new EcwRasterLayer(MapPath("~/App_Data/q3605sw.ecw"));
            ecwRasterLayer_4.UpperThreshold = double.MaxValue;
            ecwRasterLayer_4.LowerThreshold = 0;

            EcwRasterLayer ecwRasterLayer_5 = new EcwRasterLayer(MapPath("~/App_Data/q3505nw.ecw"));
            ecwRasterLayer_5.UpperThreshold = double.MaxValue;
            ecwRasterLayer_5.LowerThreshold = 0;

            EcwRasterLayer ecwRasterLayer_6 = new EcwRasterLayer(MapPath("~/App_Data/q3606se.ecw"));
            ecwRasterLayer_6.UpperThreshold = double.MaxValue;
            ecwRasterLayer_6.LowerThreshold = 0;

            Trace.Write("Default aspx: RasterLayers are created");

            // Native Server 1
            BackgroundLayer backgroundLayer = new BackgroundLayer(new GeoSolidBrush(GeoColor.FromArgb(255, 156, 187, 216)));

            CustomServerLayerOverlay layerOverlay = new CustomServerLayerOverlay("CanaveralMap1Server");
            layerOverlay.Layers.Add(ecwRasterLayer_1);
            SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay);

            Trace.Write("Default aspx: Custom server overlay is added to silverlight map connector");
            
            CustomServerLayerOverlay layerOverlay1 = new CustomServerLayerOverlay("CanaveralMap2Server");
            layerOverlay1.Layers.Add(ecwRasterLayer_2);
            SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay1);

            CustomServerLayerOverlay layerOverlay2 = new CustomServerLayerOverlay("CanaveralMap3Server");
            layerOverlay2.Layers.Add(ecwRasterLayer_3);
           SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay2);

            CustomServerLayerOverlay layerOverlay3 = new CustomServerLayerOverlay("CanaveralMap4Server");
            layerOverlay3.Layers.Add(ecwRasterLayer_1);
           SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay3);

            CustomServerLayerOverlay layerOverlay4 = new CustomServerLayerOverlay("CanaveralMap5Server");
            layerOverlay4.Layers.Add(ecwRasterLayer_2);
            SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay4);

            CustomServerLayerOverlay layerOverlay5 = new CustomServerLayerOverlay("CanaveralMap6Server");
            layerOverlay5.Layers.Add(ecwRasterLayer_3);
            SilverlightMapConnector1.ServerLayerOverlays.Add(layerOverlay5);

            Trace.Write("Page load comepleted");
        }
    }
}
